Subject: Re: [PATCH RFC v2 2/4] unit tests: Add a project plan document

From: Josh Steadmon <[email-masked]>
Date: Wed, 24 May 2023 10:40:35 -0700

On 2023.05.18 13:15, Glen Choo wrote:
> [email-masked] writes:
> 
> > Describe what we hope to accomplish by implementing unit tests, and
> > explain some open questions and milestones.
> 
> Thanks! I found this very helpful.
> 
> > diff --git a/Documentation/technical/unit-tests.txt b/Documentation/technical/unit-tests.txt
> > new file mode 100644
> > index 0000000000..7c575e6ef7
> > --- /dev/null
> > +++ b/Documentation/technical/unit-tests.txt
> > @@ -0,0 +1,47 @@
> > += Unit Testing
> > +
> > +In our current testing environment, we spend a significant amount of effort
> > +crafting end-to-end tests for error conditions that could easily be captured by
> > +unit tests (or we simply forgo some hard-to-setup and rare error conditions).
> > +Unit tests additionally provide stability to the codebase and can simplify
> > +debugging through isolation. Writing unit tests in pure C, rather than with our
> > +current shell/test-tool helper setup, simplifies test setup, simplifies passing
> > +data around (no shell-isms required), and reduces testing runtime by not
> > +spawning a separate process for every test invocation.
> 
> The stated goals make sense to me, and I believe they are worth
> restating. I believe this is mostly taken from Calvin's v1 cover letter
> 
>   https://lore.kernel.org/git/[email-masked]
> 
> so perhaps he should receive some writing credit in a commit trailer
> (Helped-by?).

Yeah, I missed some intended trailers while testing out b4. I'll make
sure it gets added back in V3.